%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%if 0%{?fedora} > 30 || 0%{?rhel} > 7
%global with_python2 0
%else
%global with_python2 1
%{!?py2dir: %global py2dir %{_builddir}/python2-%{name}-%{version}-%{release}}
%endif

%global common_desc Manage dynamic plugins for Python applications

Name:           python-stevedore
Version:        1.30.1
Release:        5%{?dist}
Summary:        Manage dynamic plugins for Python applications

Group:          Development/Languages
License:        ASL 2.0
URL:            https://github.com/openstack/stevedore
Source0:        https://tarballs.openstack.org/stevedore/stevedore-%{upstream_version}.tar.gz
BuildArch:      noarch

%if %{with_python2}
BuildRequires:  python2-devel
BuildRequires:  python2-setuptools
BuildRequires:  python2-pbr
BuildRequires:  python2-mock
BuildRequires:  python2-six
BuildRequires:  python2-testrepository
#BuildRequires:  python2-discover
#BuildRequires:  python2-oslotest
%endif

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-pbr
BuildRequires:  python3-mock
BuildRequires:  python3-six
#BuildRequires:  python3-testrepository
#BuildRequires:  python3-discover
#BuildRequires:  python3-oslotest

%description
%{common_desc}

%if %{with_python2}
%package -n python2-stevedore
Summary:        Manage dynamic plugins for Python applications
Group:          Development/Libraries
%{?python_provide:%python_provide python2-stevedore}

Requires:       python2-six
Requires:       python2-pbr

%description -n python2-stevedore
%{common_desc}
%endif

%package -n python3-stevedore
Summary:        Manage dynamic plugins for Python applications
Group:          Development/Libraries
%{?python_provide:%python_provide python3-stevedore}

Requires:       python3-six
Requires:       python3-pbr

%description -n python3-stevedore
%{common_desc}

%prep
%setup -q -n stevedore-%{upstream_version}

# let RPM handle deps
rm -f requirements.txt

%if %{with_python2}
rm -rf %{py2dir}
cp -a . %{py2dir}
%endif

%build

%if %{with_python2}
pushd %{py2dir}
%{__python3} setup.py build
popd
%endif

%{__python3} setup.py build

%install
%if %{with_python2}
pushd %{py2dir}
%{__python2} setup.py install --skip-build --root=%{buildroot}
popd
%endif

%{__python3} setup.py install -O1 --skip-build --root=%{buildroot}

%check
#TODO: reenable when commented test requirements above are available
#
#PYTHONPATH=. nosetests
#
#%if 0%{?with_python3}
#PYTHONPATH=. nosetests-%{python3_version}
#%endif

%if %{with_python2}
%files -n python2-stevedore
%license LICENSE
%doc README.rst
%{python2_sitelib}/stevedore
%{python2_sitelib}/stevedore-*.egg-info
%endif

%files -n python3-stevedore
%license LICENSE
%doc README.rst
%{python3_sitelib}/stevedore
%{python3_sitelib}/stevedore-*.egg-info

%changelog
* Tue Oct 08 2019 Merlin Mathesius <mmathesi@redhat.com> - 1.30.1-5
- Restore Python 2 subpackages for older releases of Fedora and RHEL.

* Thu Oct 03 2019 Miro Hrončok <mhroncok@redhat.com> - 1.30.1-4
- Rebuilt for Python 3.8.0rc1 (#1748018)

* Mon Aug 19 2019 Miro Hrončok <mhroncok@redhat.com> - 1.30.1-3
- Rebuilt for Python 3.8

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.30.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Mar 08 2019 RDO <dev@lists.rdoproject.org> 1.30.1-1
- Update to 1.30.1

